Package org.zkoss.stateless.sul

## Interface ICenter<I extends IAnyGroup>

- All Superinterfaces:
    `IComponent<ICenter<I>>`, `IHtmlBasedComponent<ICenter<I>>`, `ILayoutRegion<ICenter<I>>`, `ISingleChildable<ICenter<I>,​I>`, `IXulElement<ICenter<I>>`

      public interface ICenter<I extends IAnyGroup>
      extends ILayoutRegion<ICenter<I>>, ISingleChildable<ICenter<I>,​I>

  Immutable `Center` component

  A center region of a borderlayout. Note: This component doesn't support the following method, including `withSplittable(boolean)`, `withOpen(boolean)`, `withCollapsible(boolean)`, `withMaxsize(int)`, `withMinsize(int)`, `withHeight(String)`, `withWidth(String)`, `withSlidable(boolean)`, `withSlide(boolean)`, `ILayoutRegion.withClosable(boolean)` and `withVisible(boolean)`.

  Author:
    katherine
  See Also:
    `Center`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ICenter.Builder<I extends IAnyGroup>` | Builds instances of type `ICenter`.
    `static class` | `ICenter.Updater` | Builds an updater of type `ICenter` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

    - ### Nested classes/interfaces inherited from interface org.zkoss.stateless.sul.ILayoutRegion

      `ILayoutRegion.Border`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ICenter<IAnyGroup>` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default java.lang.String` | `getHeight()` | Returns the height of the component.
    `default int` | `getMaxsize()` | Returns the maximum size of the resizing component.
    `default int` | `getMinsize()` | Returns the minimum size of the resizing component.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `default java.lang.String` | `getWidth()` | Returns the width of the component.
    `default boolean` | `isCollapsible()` | Returns whether set the initial display to collapse.
    `default boolean` | `isOpen()` | Returns whether it is open (i.e., not collapsed.
    `default boolean` | `isSlidable()` | Returns whether users can slide (preview) the region when clicked on a collapsed region.
    `default boolean` | `isSlide()` | Returns whether it is slide down.
    `default boolean` | `isSplittable()` | Returns whether enable the split functionality.
    `default boolean` | `isVisible()` | Returns whether this component is visible at client.
    `static <I extends IAnyGroup> ICenter<I>` | `of​(I child)` | Return the instance with the given child.
    `static <I extends IAnyGroup> ICenter<I>` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `default ICenter` | `withCollapsible​(boolean collapsible)` | Center region can't be enabled the collapse functionality.
    `default ICenter` | `withHeight​(java.lang.String height)` | The height can't be specified in this component because its height is determined by other region components (`INorth` or `ISouth`).
    `default ICenter` | `withMaxsize​(int maxsize)` | Center region can't be enabled the maxsize.
    `default ICenter` | `withMinsize​(int minsize)` | Center region can't be enabled the minsize.
    `default ICenter` | `withOpen​(boolean open)` | Center region can't be closed.
    `default ICenter` | `withSlidable​(boolean slidable)` | Center region can't be slided.
    `default ICenter` | `withSlide​(boolean slide)` | Center region can't be slided.
    `default ICenter` | `withSplittable​(boolean splittable)` | Center region can't be enabled the split functionality.
    `default ICenter` | `withVisible​(boolean visible)` | This component can't be hidden.
    `default ICenter` | `withWidth​(java.lang.String width)` | The width can't be specified in this component because its width is determined by other region components (`IWest` or `IEast`).

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ILayoutRegion

      `getBorder, getMargins, getTitle, isAutoscroll, isClosable, isNativeScrollbar, withAutoscroll, withBorder, withBorder, withClosable, withMargins, withNativeScrollbar, withTitle`

    - ### Methods inherited from interface org.zkoss.stateless.sul.ISingleChildable

      `getChild, withChild`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final ICenter<IAnyGroup> DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zul.layout.Center"`

      Specified by:
        `getWidgetClass` in interface `IComponent<I extends IAnyGroup>`

    - #### of

          static <I extends IAnyGroup> ICenter<I> of​(I child)

      Return the instance with the given child.
      Parameters:
        `child` - The child from any group

    - #### ofId

          static <I extends IAnyGroup> ICenter<I> ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component

    - #### isVisible

          @Derived
          default boolean isVisible()

      Description copied from interface: `IComponent`
      Returns whether this component is visible at client.

      Default: `true`

      Specified by:
        `isVisible` in interface `IComponent<I extends IAnyGroup>`

    - #### withVisible

          default ICenter withVisible​(boolean visible)

      This component can't be hidden.
      Specified by:
        `withVisible` in interface `IComponent<I extends IAnyGroup>`
      Parameters:
        `visible` - Sets whether `this` component is visible at client.

        Default: `true`

      Returns:
        A modified copy of `this` object

    - #### isSplittable

          @Derived
          default boolean isSplittable()

      Description copied from interface: `ILayoutRegion`
      Returns whether enable the split functionality.

      Default: `false`.

      Specified by:
        `isSplittable` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withSplittable

          default ICenter withSplittable​(boolean splittable)

      Center region can't be enabled the split functionality.
      Specified by:
        `withSplittable` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `splittable` - Whether enable the split functionality.
      Returns:
        A modified copy of the `this` object

    - #### isOpen

          @Derived
          default boolean isOpen()

      Description copied from interface: `ILayoutRegion`
      Returns whether it is open (i.e., not collapsed. Meaningful only if `ILayoutRegion.isCollapsible()` is not false).

      Default: `true`.

      Specified by:
        `isOpen` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withOpen

          default ICenter withOpen​(boolean open)

      Center region can't be closed.
      Specified by:
        `withOpen` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `open` - Whether to open.
      Returns:
        A modified copy of the `this` object

    - #### isCollapsible

          @Derived
          default boolean isCollapsible()

      Description copied from interface: `ILayoutRegion`
      Returns whether set the initial display to collapse.

      It only applied when `ILayoutRegion.getTitle()` is not null.

      Default: `false`.

      Specified by:
        `isCollapsible` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withCollapsible

          default ICenter withCollapsible​(boolean collapsible)

      Center region can't be enabled the collapse functionality.
      Specified by:
        `withCollapsible` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `collapsible` - Whether set the initial display to collapse.
      Returns:
        A modified copy of the `this` object

    - #### getMaxsize

          @Derived
          default int getMaxsize()

      Description copied from interface: `ILayoutRegion`
      Returns the maximum size of the resizing component.

      Default: `2000`.

      Specified by:
        `getMaxsize` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withMaxsize

          default ICenter withMaxsize​(int maxsize)

      Center region can't be enabled the maxsize.
      Specified by:
        `withMaxsize` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `maxsize` - The maximum size of the resizing component.
      Returns:
        A modified copy of the `this` object

    - #### getMinsize

          @Derived
          default int getMinsize()

      Description copied from interface: `ILayoutRegion`
      Returns the minimum size of the resizing component.

      Default: `0`.

      Specified by:
        `getMinsize` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withMinsize

          default ICenter withMinsize​(int minsize)

      Center region can't be enabled the minsize.
      Specified by:
        `withMinsize` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `minsize` - The minimum size of the resizing component.
      Returns:
        A modified copy of the `this` object

    - #### getHeight

          @Derived
          @Nullable
          default java.lang.String getHeight()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the height of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getHeight` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withHeight

          default ICenter withHeight​(@Nullable
                                     java.lang.String height)

      The height can't be specified in this component because its height is determined by other region components (`INorth` or `ISouth`).
      Specified by:
        `withHeight` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `height` - The height of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### getWidth

          @Derived
          @Nullable
          default java.lang.String getWidth()

      Description copied from interface: `IHtmlBasedComponent`
      Returns the width of the component. If not specified, `null` is assumed.

      Default: `null`

      Specified by:
        `getWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`

    - #### withWidth

          default ICenter withWidth​(@Nullable
                                    java.lang.String width)

      The width can't be specified in this component because its width is determined by other region components (`IWest` or `IEast`).
      Specified by:
        `withWidth` in interface `IHtmlBasedComponent<I extends IAnyGroup>`
      Parameters:
        `width` - The width of the component.

        Default: `null`

      Returns:
        A modified copy of the `this` object

    - #### isSlide

          @Derived
          default boolean isSlide()

      Description copied from interface: `ILayoutRegion`
      Returns whether it is slide down.

      Default: `false`.

      Specified by:
        `isSlide` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withSlide

          default ICenter withSlide​(boolean slide)

      Center region can't be slided.
      Specified by:
        `withSlide` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `slide` - Whether slides down or up the region

        Default: `false`.

      Returns:
        A modified copy of the `this` object

    - #### isSlidable

          @Derived
          default boolean isSlidable()

      Description copied from interface: `ILayoutRegion`
      Returns whether users can slide (preview) the region when clicked on a collapsed region. In other words, if false, clicking on a collapsed region will open it instead of sliding.

      Default: `true`.

      Specified by:
        `isSlidable` in interface `ILayoutRegion<I extends IAnyGroup>`

    - #### withSlidable

          default ICenter withSlidable​(boolean slidable)

      Center region can't be slided.
      Specified by:
        `withSlidable` in interface `ILayoutRegion<I extends IAnyGroup>`
      Parameters:
        `slidable` - Whether users can slide this region.

        Default: `true`.

      Returns:
        A modified copy of the `this` object